import { stageManager as StageManager } from "./stage-manager";

class Objects {
  constructor() { }
  add(aggregator) {
    StageManager.getCurrentLayer().addAggregator(aggregator);
  }
  get() {
    return StageManager.getCurrentLayer().getAggregators();
  }
  getByGenericObject(genericObject) {
    return this.get().filter(e => e.genericObject.id == genericObject.id);
  }
  getByKonvaObject(konvaObject) {
    return this.get().filter(
      e =>
        e.konvaObject._id == konvaObject._id ||
        e.konvaObject.children.filter(x => x._id == konvaObject._id)[0] !=
        undefined
    );
  }
  getSelectedObjects() {
    return StageManager.getCurrentLayer().getSelectedAggregators();
  }
  setSelectedOject(aggregator) {
    if (!aggregator.visible) return;
    return StageManager.getCurrentLayer().setSelectedAggregator(aggregator);
  }
  removeSelectedOject(aggregator) {
    return StageManager.getCurrentLayer().removeSelectedAggregator(aggregator);
  }
  removeAggregator(aggregator) {

    StageManager.getCurrentLayer().removeAggregator(aggregator);
  }
}
export const objects = new Objects();
